//////////////////////////
//GDXlib_X11.h
//Written by Michael Gibson
//(c)2004-2007 under GPL
//////////////////////////
#include<X11/Xlib.h>

#define EVENT_MASK (ButtonPressMask | KeyPressMask | PointerMotionMask | ExposureMask)

int      X11return;

Display  *display;       // X server connection
Window    window;        // Window ID
Window    window2;

//widget that need their own window
Window    pulldown[640];         //pulldown menues
Window    xpm_image[640];        //images
Window    xpm_imagebutton[640];  //image button
//Window    xpm_imagemenu[640]     //menu image
Window    wlabel[640];           //standard window label

XEvent   global_event;   // Tracking events received across functions

GC          global_pen;              // GC to draw with -- black global_pen
XGCValues   global_pen_prop;         // Struct for creating GC
GC          global_pen2;             // GC to draw with -- white global_pen
XGCValues   global_pen2_prop;        // Struct for creating GC
GC          global_pen3;             // GC to draw with -- dark grey global_pen
XGCValues   global_pen3_prop;        // Struct for creating GC
GC          global_pen4;             // GC to draw with -- yellow global_pen
XGCValues   global_pen4_prop;        // Struct for creating GC

GC          global_pen5;             // GC to draw with -- grey global_pen
XGCValues   global_pen5_prop;        // Struct for creating GC

GC          global_pen6;             // GC to draw with -- dark blue global_pen
XGCValues   global_pen6_prop;        // Struct for creating GC

GC          global_button_pen[640];       // GC to draw with -- grey global_pen
XGCValues   global_button_pen_prop;        // Struct for creating GC


int  global_label_num=0;
char global_label_text[640][640];
int  global_label_x[640];
int  global_label_y[640];
int  global_label_border[640];

int  global_frame_num=0;
char global_frame_label[640][640];
int  global_frame_x1[640];
int  global_frame_y1[640];
int  global_frame_x2[640];
int  global_frame_y2[640];

int  global_hline_num=0;
int  global_hline_x[640];
int  global_hline_y[640];
int  global_hline_len[640];

int  global_vline_num=0;
int  global_vline_x[640];
int  global_vline_y[640];
int  global_vline_len[640];

int  global_button_num=0;
char global_button_text[640][640];
char global_button_func[640][640];
int  global_button_x[640];
int  global_button_y[640];

int  global_lbutton_num=0;
char global_lbutton_text[640][640];
char global_lbutton_func[640][640];
int  global_lbutton_x[640];
int  global_lbutton_y[640];

int  global_selectlist_c[640];
int  global_selectlist_r[640];
int  global_selectlist_x[640];
int  global_selectlist_y[640];
int  global_selectlist_nl[640];
int  global_selectlist_num=0;

int  global_chkbutton_x[640];
int  global_chkbutton_y[640];
char  global_chkbutton_label[640][640];
int  global_chkbutton_num=0;

int  global_textentry_x[640]; //x location
int  global_textentry_y[640]; //y location
int  global_textentry_width[640]; //pixels wide
int  global_textentry_me[640];
int  global_textentry_type[640]; //standard or password
int  global_textentry_num=0;

int global_pie_num=0;
int global_pie_x[640];
int global_pie_y[640];
int global_pie_r[640];

GC  global_image_i[640];
int global_image_x[640];
int global_image_y[640];
int global_image_w[640];
int global_image_h[640];
int global_image_num=0;

GC  global_imagebutton_i[640];
int global_imagebutton_x[640];
int global_imagebutton_y[640];
int global_imagebutton_w[640];
int global_imagebutton_h[640];
int global_imagebutton_num=0;
char global_imagebutton_func[640][640];

int global_menubar_num=0;

int global_menu_num=0;
int global_menu_parent[640];
char global_menu_label[640][640];
int global_menu_x[640];
int global_menu_x2[640];

int global_menuitem_num=0;
int global_menuitem_parent[640];
int global_menuitem_x[640]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
int global_menuitem_y[640]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
char global_menuitem_label[640][640];
char global_menuitem_func[640][640];
int global_menuitem_numinmenu[640]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};


int gdx_window_status=0;

char *X_BG = "0xCCCCCC"; //default Background 

unsigned long X_RED     = 16711680; //FF0000 color 01
unsigned long X_RED2    = 14483456; //DD0000 color 02
unsigned long X_RED3    = 12255232; //BB0000 color 03
unsigned long X_RED4    = 0;        //990000 color 04
unsigned long X_RED5    = 0;        //770000 color 05

unsigned long X_LLGREEN = 14548957; //DDFFDD
unsigned long X_LGREEN  = 11197832; //AADD88 color ??
unsigned long X_GREEN   = 65280;    //00FF00 color 11
unsigned long X_GREEN2  = 56576;    //00DD00 color 12
unsigned long X_GREEN3  = 0;        //00BB00 color 13
unsigned long X_GREEN4  = 0;        //009900 color 14
unsigned long X_GREEN5  = 0;        //007700 color 15

unsigned long X_BLUE    = 255;      //0000FF color 21
unsigned long X_BLUE2   = 221;      //0000DD color 22
unsigned long X_BLUE3   = 187;      //0000BB color 23
unsigned long X_BLUE4   = 153;      //000099 color 24
unsigned long X_BLUE5   = 119;      //000077 color 25

unsigned long X_YELLOW  = 16776960; //FFFF00 color 31
unsigned long X_YELLOW2 = 0;        //DDDD00 color 32
unsigned long X_YELLOW3 = 12303104; //BBBB00 color 33
unsigned long X_YELLOW4 = 0;        //999900 color 34
unsigned long X_YELLOW5 = 0;        //777700 color 35

unsigned long X_WHITE   = 16777215;
unsigned long X_GREY    = 13421772; //CCCCCC
unsigned long X_DGREY   =  9474192;
unsigned long X_BLACK   =        0;

