///////////////////////////////////////////////////
/// GDX GEDCOM List
/// 0.0.1 Initial Release
/// 0.1.0 General working release
/// 0.2.0 bug fix
/// 0.3.0 works with other modules
/// 0.3.1 made to work with new individual displayer
/// 0.6.0 adds new buttons and link to family
/// Written By Michael Gibson under the GPL
/// (c) 2003 - 2007
//////////////////////////////////////////////////

#include <stdio.h>
#include <string.h>
#include "GDXlib.h"

int button_01,button_02,button_03,button_04,button_05;
int button_06,button_07,button_08,button_09,button_10,button_11,selectlist;
int downbutton,upbutton;
char namelist[640][640];
char *r_version="0.7.5";
int selectrow=0;
void print_report(void);
int indi;
char last_action[5];
char filename[50];
char indi_name[200];
int number_of_names=0;
int x=0;
char temp[200];
FILE *fp;

////////////////////////////////
///far up list
///////////////////////////////
void faruplist(void){

  gdx_selectlist_obj.position[selectlist]=0;

}

///////////////////////////////
///far down list
//////////////////////////////
void fardownlist(void){

  int listpos;

   //511 max entries - 35 rows + 1 = 477 

  if(number_of_names < 477){ 
     listpos=number_of_names-34;
  }
  else{ 
     listpos=477;
  }

  gdx_selectlist_obj.position[selectlist]=listpos;

}

/////////////////////////////////////////////
///// showdata
////////////////////////////////////////////
void showdata(void){
  char systemstring[300];
  char istring[150];
  char istring2[6];
  int xxx;
  sprintf(istring,"%s",gdx_selectlist_obj.item[gdx_selectlist_obj.selected[selectlist]][selectlist]);
  strcpy(istring2,"     "); 
  for(xxx=0;xxx<6;xxx++){
    istring2[xxx]=istring[xxx];
  }
  istring2[xxx]='\0';
  printf("./gedindi %s %s &\n",filename,istring2);
  sprintf(systemstring,"./gedindi %s %s &",filename,istring2);
  system(systemstring);
}


/////////////////////////////////////////////
///// showdata2
////////////////////////////////////////////
void showdata2(void){
  char systemstring[300];
  char istring[150];
  char istring2[6];
  int xxx;
  sprintf(istring,"%s",gdx_selectlist_obj.item[gdx_selectlist_obj.selected[selectlist]][selectlist]);
  strcpy(istring2,"     ");
  for(xxx=0;xxx<6;xxx++){
    istring2[xxx]=istring[xxx];
  }
  istring2[xxx]='\0';
  printf("./gedindi %s %s &\n",filename,istring2);
  sprintf(systemstring,"./geddeat %s %s &",filename,istring2);
  system(systemstring);
}

/////////////////////////////////////////////
///// showdata3
////////////////////////////////////////////
void showdata3(void){
  char systemstring[300];
  char istring[150];
  char istring2[6];
  int xxx;
  sprintf(istring,"%s",gdx_selectlist_obj.item[gdx_selectlist_obj.selected[selectlist]][selectlist]);
  strcpy(istring2,"     ");
  for(xxx=0;xxx<6;xxx++){
    istring2[xxx]=istring[xxx];
  }
  istring2[xxx]='\0';
  printf("./gedindi %s %s &\n",filename,istring2);
  sprintf(systemstring,"./geddate %s %s &",filename,istring2);
  system(systemstring);
}


/////////////////////////////////////////////
//// help    
/////////////////////////////////////////////
void help(void){

 x_imgbox("images/helptext.xpm","Help");
}

/////////////////////////////////////////////
///// parent 
////////////////////////////////////////////
void parent(void){
  char systemstring[300];
  char istring[150];
  char istring2[6];
  int xxx;
  sprintf(istring,"%s",gdx_selectlist_obj.item[gdx_selectlist_obj.selected[selectlist]][selectlist]);
  xxx=0;
  for(xxx=0;xxx<6;xxx++){
    istring2[xxx]=istring[xxx];
  }
 istring2[xxx]='\0';
  printf("./gedtree %s %s &\n",filename,istring2);
  sprintf(systemstring,"./gedtree %s %s &",filename,istring2);
  system(systemstring);
}

/////////////////////////////////////////////
///// family
////////////////////////////////////////////
void family(void){
  char systemstring[300];
  char istring[150];
  char istring2[6];
  int xxx;
  sprintf(istring,"%s",gdx_selectlist_obj.item[gdx_selectlist_obj.selected[selectlist]][selectlist]);
  xxx=0;
  for(xxx=0;xxx<5;xxx++){
    istring2[xxx]=istring[xxx];
  }
 istring2[xxx]='\0';
  printf("./gedchild %s %s 1 &\n",istring2,filename);
  sprintf(systemstring,"./gedchild %s %s 1 &",istring2,filename);
  system(systemstring);
}


////////////////////////////////////
//// load report module
///////////////////////////////////
void l_report(void){
   char systemstring[50];

   sprintf(systemstring,"./gedreport %s -h &",filename);
   system(systemstring);
}

/////////////////////////////////////////////////////
///// quit app
/////////////////////////////////////////////////////
static void destroy(void)
{
    gdx_closewindow();
}




/////////////////////////////////////////////////////
///// add spouce 
/////////////////////////////////////////////////////
static void spouce(void)
{

  char spouce_string[90];

  char istring[150];
  char istring2[6];
  int xxx;
  sprintf(istring,"%s",gdx_selectlist_obj.item[gdx_selectlist_obj.selected[selectlist]][selectlist]);
  xxx=0;
  for(xxx=0;xxx<5;xxx++){
    istring2[xxx]=istring[xxx];
  }
 istring2[xxx]='\0';

  if(istring[6]=='F')
    sprintf(spouce_string,"./gedadd_spouce %s %s M",istring2,filename);
  if(istring[6]=='M')
    sprintf(spouce_string,"./gedadd_spouce %s %s F",istring2,filename);
  system(spouce_string);

}
////////////////////////////////////////////////
// add event
////////////////////////////////////////////////
static void sevent(void){

 char event_string[90];

 char istring[150];
 char istring2[6];
 int xxx;
 sprintf(istring,"%s",gdx_selectlist_obj.item[gdx_selectlist_obj.selected[selectlist]][selectlist]);
 xxx=0;
 for(xxx=0;xxx<5;xxx++){
    istring2[xxx]=istring[xxx];
 }
 istring2[xxx]='\0';

 sprintf(event_string,"./gedadd_event %s %s",istring2,filename);
 system(event_string);

}

//////////////////////////////////////////
/// int main()
/////////////////////////////////////////
int main(int argc, char **argv)
{

  char stringnumofnames[10];
  int label1,label2,label3;
 
  if(argc==2){ 
    sprintf(filename,"%s",argv[1]); }
  else{ 
    printf("No filename specified\n");
    exit(0);
  }
                                                                                                                             
  x_open(); 
                                                                                                                             
  /* create a new window */
  gdx_window("GEDCOM List",600,400); 
  gdx_setwindowbg("images/bg.xpm",1);

  button_01 = gdx_imagebutton(5,25,"images/close.xpm",destroy);
  button_02 = gdx_imagebutton(5,50,"images/list.xpm",print_report);
  button_03 = gdx_imagebutton(5,75,"images/hnew.xpm",l_report);
  button_04 = gdx_imagebutton(5,100,"images/viewi.xpm",showdata);
  button_10 = gdx_imagebutton(5,125,"images/deat.xpm",showdata2);
  button_11 = gdx_imagebutton(5,150,"images/vevent.xpm",showdata3);
  button_05 = gdx_imagebutton(5,175,"images/pari.xpm",parent);
  button_06 = gdx_imagebutton(5,200,"images/chil.xpm",family);
  button_07 = gdx_imagebutton(5,225,"images/marr.xpm",spouce);
  button_08 = gdx_imagebutton(5,250,"images/sevent.xpm",sevent);

  button_09 = gdx_imagebutton(5,300,"images/help.xpm",help);



  upbutton  = gdx_imagebutton(555,35,"images/uup.xpm",faruplist);
  downbutton= gdx_imagebutton(555,370,"images/ddown.xpm",fardownlist);
  label3=gdx_label("ID    Gender  Name                                      Birth date    Death date        ",40,30,1);
  gdx_setlabelbg("images/menu_image.xpm",1,label3);

  print_report();

  label1=gdx_label("Number of individuals:",35,15,0);
  gdx_setlabelbg("images/bg.xpm",1,label1);

  sprintf(stringnumofnames,"%d",number_of_names);
  label2=gdx_label(stringnumofnames,175,15,1);
  gdx_setlabelbg("images/white.xpm",1,label2);
  selectlist = gdx_selectlist(40,35,640,namelist,50,35);
  gdx_selectlist_obj.position[selectlist]=1;
  gdx_selectlist_obj.selected[selectlist]=1;
  gdx_main ();
  x_close();
  return(0);
}


//////////////////////////////////////////
/// print_report()
/////////////////////////////////////////
void print_report()
{

  char indi_sex[9];
  char indi_bd[20];
  char indi_dd[20];
  char temp_list[90];


  if((fp=fopen(filename,"r"))==NULL ){
     printf("GEDCOM list: Sorry, no file found. \n");
     exit(0);
  }
   
   number_of_names=-1;
  
do{
  fgets(temp,80,fp);

    for(x=0;x<50;x++){
      if(temp[x]=='\r' || temp[x]=='\n'){
         temp[x]= ' ';
      }
    }


  if(temp[0]=='0' && temp[2]=='@' && temp[3]=='I'){         //Individual 0 level start of record
      temp[0]=' ';
      for(x=0;x<80;x++) if(temp[x]=='@' ||temp[x]=='I') temp[x]=' ';
      indi=atoi(temp);
  }

  if(temp[0]=='1' && temp[2]=='N' && temp[3]=='A'){     ///1 NAME
     number_of_names++;
     for(x=7;x<80;x++){temp[x-7]=temp[x];} 
     sprintf(indi_name,"%s",temp);
     if(indi >=1){
       sprintf(temp_list,"%04d  %6s  %-40s",indi,indi_sex,indi_name);
       strcpy(namelist[number_of_names],temp_list);
      }
      else{
         sprintf(temp_list,"Submitted by: %s",indi_name);
         strcpy(namelist[number_of_names],temp_list);
      }
  }


  if(temp[0]=='1' && temp[2]=='S' && temp[3]=='E'){ //1 SEX
     indi_sex[0]=temp[6];
     if(indi_sex[0]=='M')strcpy(indi_sex,"Male  ");
     if(indi_sex[0]=='F')strcpy(indi_sex,"Female");
       sprintf(temp_list,"%04d  %6s  %-40s",indi,indi_sex,indi_name);
       strcpy(namelist[number_of_names],temp_list);
  }


  if(temp[0]=='2' && temp[2]=='D' && temp[3]=='A'){   ///2 DATE
     for(x=7;x<80;x++){temp[x-7]=temp[x];}
     if(last_action[0]=='B' && last_action[1]=='I'){
       strcpy(indi_bd,temp);
       sprintf(temp_list,"%04d  %6s  %-40s  % 11s ",indi,indi_sex,indi_name,indi_bd);
       strcpy(namelist[number_of_names],temp_list);
     } 
     if(last_action[0]=='D' && last_action[1]=='E'){
       strcpy(indi_dd,temp);
       sprintf(temp_list,"%04d  %6s  %-40s  % 11s  % 11s",indi,indi_sex,indi_name,indi_bd,indi_dd);
       strcpy(namelist[number_of_names],temp_list);
     }
  }


  if(temp[0]=='1' && temp[2]=='B' && temp[3]=='I'){ //1 BIRT
     strcpy(last_action,"BIRT");
  }
                                                                                                                             
  if(temp[0]=='1' && temp[2]=='D' && temp[3]=='E' && temp[4] =='A'){ //1 DEAT
     strcpy(last_action,"DEAT");
  }

  if(temp[0]=='1' && temp[2]=='C' && temp[3]=='H'){ //1 CHAN
     strcpy(last_action,"CHAN");
  }


}while(temp[0] !='0' || temp[2] !='T');


fclose(fp);

}
